----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 02/16/2016 02:10:44 PM
-- Design Name: 
-- Module Name: mpg - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
-- use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mpg is
    Port ( clk : in STD_LOGIC;
           btn : in STD_LOGIC_vector(1 downto 0);
           enable : out STD_LOGIC_vector(1 downto 0)
           );
end mpg;

architecture Behavioral of mpg is
    signal cnt : std_logic_vector(15 downto 0);
    signal q1  : std_logic_vector(1 downto 0):=(others=>'0');
    signal q2  : std_logic_vector(1 downto 0):=(others=>'0');
    signal q3  : std_logic_vector(1 downto 0):=(others=>'0');
     
begin
    --counter
    process(clk, cnt)
    begin
        if rising_edge(clk) then
            cnt <= cnt + 1;
        end if;
    end process;
    
    process(clk, cnt, btn)
    begin
        if rising_edge(clk) then
            if cnt = x"FFFF" then
                q1 <= btn;
            end if;
        end if;
    end process;
    
    process(clk, q1)
    begin
        if rising_edge(clk) then
            q2 <= q1;
        end if;
    end process;

    process(clk, q2)
    begin
        if rising_edge(clk) then
            q3 <= q2;
        end if;
    end process;
    
    enable <= not q3 and q2;
    
end Behavioral;